package uoc.multimediadegree.com.e_lactancia_app;

import android.annotation.TargetApi;
import android.content.Context;
import android.database.Cursor;
import android.os.Build;
import android.support.v4.widget.CursorAdapter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import uoc.multimediadegree.com.e_lactancia_app.modelo.MyContracts;

/**
 * {@link CursorAdapter} personalizado
 **/
public class Adaptador_BD extends CursorAdapter {

    public static final int HISTORIAL = 1;
    public static final int FAVORITOS = 2;

    private int tipoAdaptador;
    private TextView termino;
    private TextView fecha;
    private View riesgoIndicator;

    public Adaptador_BD(Context context, int id) {
        super(context, null, 0);
        this.tipoAdaptador = id;
    }

    @Override
    public void bindView(View view, Context context, Cursor cursor) {
        switch( tipoAdaptador ){
            case HISTORIAL:
                termino = (TextView) view.findViewById(R.id.item_lista_historial_txt_termino);
                fecha = (TextView) view.findViewById(R.id.item_lista_historial_txt_fecha);
                item_Lista(view, context, cursor);
                break;

            case FAVORITOS:
                termino = (TextView) view.findViewById(R.id.item_lista_favorito_txt_termino);
                riesgoIndicator = (View) view.findViewById(R.id.item_lista_favorito_view_indicator);
                item_Lista(view, context, cursor);
                break;
        }
    }

    private void item_Lista(View view, Context context, Cursor cursor){
//        if( cursor.moveToFirst() != false ) {
            switch (tipoAdaptador) {
                case HISTORIAL:
                    termino.setText(cursor.getString(
                            cursor.getColumnIndex(MyContracts.Columnas.HIST_TERM)));
                    fecha.setText(cursor.getString(
                            cursor.getColumnIndex(MyContracts.Columnas.HIST_DATE)));
                    break;

                case FAVORITOS:
                    termino.setText(cursor.getString(
                            cursor.getColumnIndex(MyContracts.Columnas.FAV_TERM)));
                    int estado = cursor.getInt(
                            cursor.getColumnIndex(MyContracts.Columnas.FAV_RISK));
                    setRiesgoIndicador(estado);
                    break;
            }
//        }
    }

    private void setRiesgoIndicador( int estado ){
        switch (estado) {
            case 0:
                riesgoIndicator.setBackgroundResource(R.drawable.indicator_riesgo_muy_bajo);
                break;
            case 1:
                riesgoIndicator.setBackgroundResource(R.drawable.indicator_riesgo_bajo);
                break;
            case 2:
                riesgoIndicator.setBackgroundResource(R.drawable.indicator_riesgo_alto);
                break;
            case 3:
                riesgoIndicator.setBackgroundResource(R.drawable.indicator_riesgo_muy_alto);
                break;
        }
    }

    @Override
    public View newView(Context context, Cursor cursor, ViewGroup parent) {
        LayoutInflater inflater = LayoutInflater.from(parent.getContext());
        switch( tipoAdaptador ){
            case HISTORIAL:
                return inflater.inflate(R.layout.item_lista_historial, parent, false);

            case FAVORITOS:
                return inflater.inflate(R.layout.item_lista_favorito, parent, false);
        }
        return null;
    }

}
