package uoc.multimediadegree.com.e_lactancia_app.modelo;

import android.content.ContentValues;
import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

/**
 * Clase envoltura para el gestor de Bases de datos
 */
class DatabaseHelper extends SQLiteOpenHelper {


    public DatabaseHelper(Context context,
                          String name,
                          SQLiteDatabase.CursorFactory factory,
                          int version) {
        super(context, name, factory, version);
    }

    public void onCreate(SQLiteDatabase database) {
        createTables(database); // Crear las tablas
//        loadDummyData(database); // Cargar datos de prueba
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {

    }

        /**
         * Crear tabla en la base de datos
         *
         * @param database Instancia de la base de datos
         */
    private void createTables(SQLiteDatabase database) {
        String cmd;
        cmd = "CREATE TABLE " + MyContracts.USUARIO + " (" +
                MyContracts.Columnas._ID + " INTEGER PRIMARY KEY AUTOINCREMENT, " +
                MyContracts.Columnas.USER_NAME + " TEXT, " +
                MyContracts.Columnas.USER_EMAIL + " TEXT, " +
                MyContracts.Columnas.USER_PROFLIE + " TEXT);";
        database.execSQL(cmd);
        cmd = "CREATE TABLE " + MyContracts.FAVORITO + " (" +
                MyContracts.Columnas._ID + " INTEGER PRIMARY KEY AUTOINCREMENT, " +
                MyContracts.Columnas.FAV_TERM + " TEXT, " +
                MyContracts.Columnas.FAV_RISK + " INTEGER, " +
                MyContracts.Columnas.FAV_REFWEB + " TEXT);";
        database.execSQL(cmd);
        cmd = "CREATE TABLE " + MyContracts.HISTORIAL + " (" +
                MyContracts.Columnas._ID + " INTEGER PRIMARY KEY AUTOINCREMENT, " +
                MyContracts.Columnas.HIST_TERM + " TEXT, " +
                MyContracts.Columnas.HIST_DATE + " DATE, " +
                MyContracts.Columnas.HIST_REFWEB + " TEXT);";
        database.execSQL(cmd);
        cmd = "CREATE TABLE " + MyContracts.SEARCH + " (" +
                MyContracts.Columnas._ID + " INTEGER PRIMARY KEY AUTOINCREMENT, " +
                MyContracts.Columnas.SEARCH_TERM + " TEXT, " +
                MyContracts.Columnas.SEARCH_REFWEB + " TEXT);";
        database.execSQL(cmd);
        cmd = "CREATE VIRTUAL TABLE " + MyContracts.FTS_VIRTUAL_TABLE +
                        " USING fts3 (" +
                MyContracts.Columnas.SUGGEST_TERM + ", " +
                MyContracts.Columnas.SUGGEST_OTHERTERM + ", " +
                MyContracts.Columnas.SUGGEST_REFWEB + ");";


        database.execSQL(cmd);
    }

    /**
     * Carga datos de ejemplo en la tabla
     * @param database Instancia de la base de datos
     */
    private void loadDummyData(SQLiteDatabase database) {
        ContentValues values = new ContentValues();
        values.put(MyContracts.Columnas.USER_NAME, "Rafa Serra");
        values.put(MyContracts.Columnas.USER_EMAIL, "serra.raf@gmail.com");
        values.put(MyContracts.Columnas.USER_PROFLIE, "Padre/Madre");
        database.insert(MyContracts.USUARIO, null, values);

        values = new ContentValues();
        values.put(MyContracts.Columnas.FAV_TERM, "Abacavir");
        values.put(MyContracts.Columnas.FAV_RISK, 0);
        values.put(MyContracts.Columnas.FAV_REFWEB, "1");
        database.insert(MyContracts.FAVORITO, null, values);

        values = new ContentValues();
        values.put(MyContracts.Columnas.FAV_TERM, "Abatacept");
        values.put(MyContracts.Columnas.FAV_RISK, 1);
        values.put(MyContracts.Columnas.FAV_REFWEB, "2");
        database.insert(MyContracts.FAVORITO, null, values);

        values = new ContentValues();
        values.put(MyContracts.Columnas.FAV_TERM, "Acetato de Ganirelix");
        values.put(MyContracts.Columnas.FAV_RISK, 1);
        values.put(MyContracts.Columnas.FAV_REFWEB, "1659");
        database.insert(MyContracts.FAVORITO, null, values);

        values = new ContentValues();
        values.put(MyContracts.Columnas.FAV_TERM, "Achicoria");
        values.put(MyContracts.Columnas.FAV_RISK, 0);
        values.put(MyContracts.Columnas.FAV_REFWEB, "18");
        database.insert(MyContracts.FAVORITO, null, values);

        values = new ContentValues();
        values.put(MyContracts.Columnas.FAV_TERM, "Amapola");
        values.put(MyContracts.Columnas.FAV_RISK, 2);
        values.put(MyContracts.Columnas.FAV_REFWEB, "69");
        database.insert(MyContracts.FAVORITO, null, values);

        values = new ContentValues();
        values.put(MyContracts.Columnas.FAV_TERM, "Anemia Materna ");
        values.put(MyContracts.Columnas.FAV_RISK, 0);
        values.put(MyContracts.Columnas.FAV_REFWEB, "100");
        database.insert(MyContracts.FAVORITO, null, values);

        values = new ContentValues();
        values.put(MyContracts.Columnas.FAV_TERM, "Anidulafungina  ");
        values.put(MyContracts.Columnas.FAV_RISK, 1);
        values.put(MyContracts.Columnas.FAV_REFWEB, "1635");
        database.insert(MyContracts.FAVORITO, null, values);

        values = new ContentValues();
        values.put(MyContracts.Columnas.FAV_TERM, "(Anticonceptivos combinados Estrógeno + Progestágeno) ");
        values.put(MyContracts.Columnas.FAV_RISK, 1);
        values.put(MyContracts.Columnas.FAV_REFWEB, "112");
        database.insert(MyContracts.FAVORITO, null, values);

        values = new ContentValues();
        values.put(MyContracts.Columnas.FAV_TERM, "Aliskiren");
        values.put(MyContracts.Columnas.FAV_RISK, 1);
        values.put(MyContracts.Columnas.FAV_REFWEB, "55");
        database.insert(MyContracts.FAVORITO, null, values);
    }
}
