package uoc.multimediadegree.com.e_lactancia_app.ui;

import android.content.ContentUris;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.nfc.Tag;
import android.os.Bundle;
import android.support.design.widget.AppBarLayout;
import android.support.design.widget.CollapsingToolbarLayout;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.CardView;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;

import com.android.volley.Request;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonObjectRequest;
import com.google.android.gms.appindexing.Action;
import com.google.android.gms.appindexing.AppIndex;
import com.google.android.gms.common.api.GoogleApiClient;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import uoc.multimediadegree.com.e_lactancia_app.Adaptador_ArrayList;
import uoc.multimediadegree.com.e_lactancia_app.R;
import uoc.multimediadegree.com.e_lactancia_app.modelo.JSONAdapter;
import uoc.multimediadegree.com.e_lactancia_app.modelo.JSONFiles;
import uoc.multimediadegree.com.e_lactancia_app.modelo.MyContracts;
import uoc.multimediadegree.com.e_lactancia_app.modelo.MySingleton;

public class ActividadDetalleTermino extends AppCompatActivity {

    private Menu menu;
    private String refWeb;
    /**
     * ATTENTION: This was auto-generated to implement the App Indexing API.
     * See https://g.co/AppIndexing/AndroidStudio for more information.
     */
    private GoogleApiClient client;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.actividad_detalle_termino);

        setToolbar();// Añadir action bar
        if (getSupportActionBar() != null) // Habilitar up button
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        Intent i = getIntent();
        refWeb = i.getStringExtra("refWeb");
        String id = i.getStringExtra("id");
        if (id != null) {
            refWeb = getRefWeb(id);
        }

        JSONAdapter_Term adaptador = new JSONAdapter_Term(this);
        adaptador.term(refWeb);

    }

    private String getRefWeb(String id) {
        Cursor c = getContentResolver().query(MyContracts.CONTENT_URI_SUGGEST, null, id, null, null, null);
        if (c != null) {
            c.moveToFirst();
        }
        String refWeb = c.getString(0);

        c.close();
        return refWeb;
    }

    private void setFavouriteIcon(String id) {
        int i;
        i = Integer.parseInt(id);
        Uri uri = ContentUris.withAppendedId(MyContracts.CONTENT_URI_FAVORITO, i);
        Cursor c = getContentResolver().query(
                uri,
                null, null, null, null);

        if (c.moveToFirst() == false) {
            menu.findItem(R.id.action_add_favourites_fill).setVisible(false);
            menu.findItem(R.id.action_add_favourites_empty).setVisible(true);
        } else {
            menu.findItem(R.id.action_add_favourites_fill).setVisible(true);
            menu.findItem(R.id.action_add_favourites_empty).setVisible(false);
        }
        c.close();
    }

    private void addTermToNavHist() {
        Uri uri = ContentUris.withAppendedId(MyContracts.CONTENT_URI_HISTORIAL, Integer.parseInt(refWeb));
        Cursor c = getContentResolver().query(
                uri,
                null, null, null, null);

        if (c.moveToFirst() != false) {
            getContentResolver().delete(MyContracts.CONTENT_URI_HISTORIAL, MyContracts.Columnas.HIST_REFWEB + " = " + refWeb, null);
        }
        c.close();

        ContentValues values = new ContentValues();
        TextView termino = (TextView) findViewById(R.id.activity_detail_txt_termino);
        SimpleDateFormat dateFormat = new SimpleDateFormat("dd-MM-yyyy HH:mm:ss");
        Date date = new Date();
        values.put(MyContracts.Columnas.HIST_TERM, termino.getText().toString());
        values.put(MyContracts.Columnas.HIST_REFWEB, refWeb);
        values.put(MyContracts.Columnas.HIST_DATE, dateFormat.format(date));
        getContentResolver().insert(MyContracts.CONTENT_URI_HISTORIAL, values);
    }

    private void setToolbar() {
        // Añadir la Toolbar
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
    }

    private void showSnackBar(String msg) {
        Snackbar
                .make(findViewById(R.id.coordinator), msg, Snackbar.LENGTH_LONG)
                .show();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_detail, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();

        switch (id) {
            case R.id.action_add_favourites_empty:
                showSnackBar(getResources().getString(R.string.userMessage_addFavourite));
                menu.findItem(R.id.action_add_favourites_fill).setVisible(true);
                menu.findItem(R.id.action_add_favourites_empty).setVisible(false);

                ContentValues values = new ContentValues();
                TextView termino = (TextView) findViewById(R.id.activity_detail_txt_termino);
                TextView riesgoValue = (TextView) findViewById(R.id.activity_detail_int_riesgo);
                values.put(MyContracts.Columnas.FAV_TERM, termino.getText().toString());
                values.put(MyContracts.Columnas.FAV_REFWEB, refWeb);
                values.put(MyContracts.Columnas.FAV_RISK, Integer.parseInt(riesgoValue.getText().toString()));
                getContentResolver().insert(MyContracts.CONTENT_URI_FAVORITO, values);
                return true;
            case R.id.action_add_favourites_fill:
                showSnackBar(getResources().getString(R.string.userMessage_delFavourite));
                menu.findItem(R.id.action_add_favourites_fill).setVisible(false);
                menu.findItem(R.id.action_add_favourites_empty).setVisible(true);

                getContentResolver().delete(MyContracts.CONTENT_URI_FAVORITO, MyContracts.Columnas.FAV_REFWEB + " = " + refWeb, null);
                return true;
            case R.id.action_share:
                shareIt();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    private void shareIt() {
        //sharing implementation here
        Intent sharingIntent = new Intent(Intent.ACTION_SEND);
        sharingIntent.setType("text/plain");
        sharingIntent.putExtra(Intent.EXTRA_SUBJECT, getResources().getString(R.string.share_subject));
        sharingIntent.putExtra(Intent.EXTRA_TEXT, getResources().getString(R.string.share_content) +
                getResources().getString(R.string.URL_e_lactancia_org) + "/producto/" + refWeb);
        startActivity(Intent.createChooser(sharingIntent, getResources().getString(R.string.share_windowTitle)));
    }

    @Override
    public boolean onPrepareOptionsMenu(Menu menu) {
        super.onPrepareOptionsMenu(menu);
        this.menu = menu;
        setFavouriteIcon(refWeb);
        return true;
    }

    public void setAlternativeList( String[] alternativeList ){
        ListView alternativas = (ListView) findViewById(R.id.activity_detail_lstView_alternativas);
        ArrayAdapter<String> adaptador = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, alternativeList);
        alternativas.setAdapter(adaptador);
    }

    public void setGroupList( String[] groupList ){
        ListView groups = (ListView) findViewById(R.id.activity_detail_lstView_groups);
        ArrayAdapter<String> adaptador = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, groupList);
        groups.setAdapter(adaptador);
    }

    private class JSONAdapter_Term {
        private static final String TAG = "JSONAdapter";
        private Context context;
        JsonObjectRequest jsArrayRequest;

        public JSONAdapter_Term(Context context) {
            this.context = context;
        }

        public void term(String terminoRefWeb) {
            jsArrayRequest = new JsonObjectRequest(
                    Request.Method.GET,
                    JSONAdapter.URL_BASE + JSONAdapter.URL_JSON_TERM + terminoRefWeb,
                    null,
                    new Response.Listener<JSONObject>() {
                        @Override
                        public void onResponse(JSONObject response) {
                            parseJsonTerm(response);
                        }
                    },
                    new Response.ErrorListener() {
                        @Override
                        public void onErrorResponse(VolleyError error) {
                            Log.d(TAG, "Error Respuesta en JSON: " + error.getMessage());
                        }
                    }
            );
            MySingleton.getInstance(getApplicationContext()).addToRequestQueue(jsArrayRequest);
        }

        private void parseJsonTerm(JSONObject jsonObject) {
            CollapsingToolbarLayout collapser =
                    (CollapsingToolbarLayout) findViewById(R.id.activity_detail_collapser);

            TextView termino = (TextView) findViewById(R.id.activity_detail_txt_termino);
            TextView riesgoComentario = (TextView) findViewById(R.id.activity_detail_txt_riesgoComentario);
            TextView riesgoValue = (TextView) findViewById(R.id.activity_detail_int_riesgo);
            TextView descripcion = (TextView) findViewById(R.id.activity_detail_txt_descripcion);
            AppBarLayout app_bar = (AppBarLayout) findViewById(R.id.app_bar);

            TextView farma_peso = (TextView) findViewById(R.id.activity_detail_txt_farma_peso);
            TextView farma_union = (TextView) findViewById(R.id.activity_detail_txt_farma_union);
            TextView farma_volumen = (TextView) findViewById(R.id.activity_detail_txt_farma_volumen);
            TextView farma_tiempo = (TextView) findViewById(R.id.activity_detail_txt_farma_tiempo);
            TextView farma_semivida = (TextView) findViewById(R.id.activity_detail_txt_farma_semivida);
            TextView farma_biodisp = (TextView) findViewById(R.id.activity_detail_txt_farma_biodisp);

            JSONObject jsonObj = null;
            JSONArray jsonArray = null;

            try {
                jsonObj = jsonObject.getJSONObject(JSONAdapter.JSON_SECTION_PRODUCT);
                try {
                    int riesgoNivel = jsonObj.getInt("riesgo__nivel");
                    riesgoValue.setText(String.valueOf(riesgoNivel));
                    setRiesgoToolBarBackground(riesgoNivel, collapser, app_bar);

                    termino.setText(jsonObj.getString("nombre_es"));
                    riesgoComentario.setText(jsonObj.getString("riesgo__descripcion_es"));
                    descripcion.setText(jsonObj.getString("comentario_es"));
                    //FARMACOCINETICA
                    if( jsonObj.getString("peso_molecular") != "" ) {
                        farma_peso.setText(jsonObj.getString("peso_molecular") + " daltons");
                        farma_union.setText(jsonObj.getString("union_proteinas") + " %");
                        farma_volumen.setText(jsonObj.getString("volumen_distrib") + " L/kG");
                        farma_tiempo.setText(jsonObj.getString("t_maximo") + " horas");
                        farma_semivida.setText(jsonObj.getString("t_medio") + " horas");
                        farma_biodisp.setText(jsonObj.getString("biodisponibilidad") + " %");
                    }else{
                        CardView cardFarma = (CardView) findViewById(R.id.activity_detail_cardView_farma);
                        cardFarma.setVisibility(View.INVISIBLE);
                    }

                    addTermToNavHist();
                } catch (JSONException e) {
                    Log.e(TAG, "Error de parsing: " + e.getMessage());
                }
                //*** LISTA ALTERNATIVAS ***
                jsonArray = jsonObject.getJSONArray(JSONAdapter.JSON_SECTION_ALTERNATIVES);

                String[] listOfAlternatives = new String[jsonArray.length()];
                try {
                    for (int i = 0; i < jsonArray.length(); i++) {
                        JSONObject objeto = jsonArray.getJSONObject(i);
                        listOfAlternatives[i] = objeto.getString("nombre_es");
                    }
                    setAlternativeList(listOfAlternatives);
                } catch (JSONException e) {
                    Log.e(TAG, "Error de parsing: " + e.getMessage());
                }

                //*** LISTA GRUPOS ***
                jsonArray = jsonObject.getJSONArray(JSONAdapter.JSON_SECTION_GROUPS);

                String[] listOfGroups = new String[jsonArray.length()];
                try {
                    for (int i = 0; i < jsonArray.length(); i++) {
                        JSONObject objeto = jsonArray.getJSONObject(i);
                        listOfGroups[i] = objeto.getString("nombre_es");
                    }
                    setGroupList(listOfGroups);
                } catch (JSONException e) {
                    Log.e(TAG, "Error de parsing: " + e.getMessage());
                }

            } catch (JSONException e) {
                e.printStackTrace();
            }
        }

        private void setRiesgoIndicador(int estado, View riesgoIndicator) {
            switch (estado) {
                case 0:
                    riesgoIndicator.setBackgroundResource(R.drawable.indicator_riesgo_muy_bajo);
                    break;
                case 1:
                    riesgoIndicator.setBackgroundResource(R.drawable.indicator_riesgo_bajo);
                    break;
                case 2:
                    riesgoIndicator.setBackgroundResource(R.drawable.indicator_riesgo_alto);
                    break;
                case 3:
                    riesgoIndicator.setBackgroundResource(R.drawable.indicator_riesgo_muy_alto);
                    break;
            }
        }

        private void setRiesgoToolBarBackground(int estado, CollapsingToolbarLayout collapser, AppBarLayout app_bar) {
            String riesgo = null;
            switch (estado) {
                case 0:
                    collapser.setContentScrimResource(R.drawable.gradient_riesgo_muy_bajo);
                    app_bar.setBackgroundResource(R.drawable.gradient_riesgo_muy_bajo);
                    riesgo = getString(R.string.txt_riesgo_0);
                    break;
                case 1:
                    collapser.setContentScrimResource(R.drawable.gradient_riesgo_bajo);
                    app_bar.setBackgroundResource(R.drawable.gradient_riesgo_bajo);
                    riesgo = getString(R.string.txt_riesgo_1);
                    break;
                case 2:
                    collapser.setContentScrimResource(R.drawable.gradient_riesgo_alto);
                    app_bar.setBackgroundResource(R.drawable.gradient_riesgo_alto);
                    riesgo = getString(R.string.txt_riesgo_2);
                    break;
                case 3:
                    collapser.setContentScrimResource(R.drawable.gradient_riesgo_muy_alto);
                    app_bar.setBackgroundResource(R.drawable.gradient_riesgo_muy_alto);
                    riesgo = getString(R.string.txt_riesgo_3);
                    break;
            }
            collapser.setTitle(riesgo);
        }
    }

}
