package uoc.multimediadegree.com.e_lactancia_app.ui;


import android.graphics.Color;
import android.os.Bundle;
import android.support.design.widget.AppBarLayout;
import android.support.design.widget.TabLayout;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentStatePagerAdapter;
import android.support.v4.view.ViewPager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

import uoc.multimediadegree.com.e_lactancia_app.R;

import java.util.ArrayList;
import java.util.List;

public class FragmentoCuenta extends Fragment {

    private AppBarLayout appBar;
    private TabLayout pestanas;
    private ViewPager viewPager;
    private int pestanaDefecto = 0;

    public FragmentoCuenta(){
    }

    public void setPestanaDefecto(int pestanaDefecto) {
        this.pestanaDefecto = pestanaDefecto;
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragmento_paginado, container, false);

        if (savedInstanceState == null) {
            insertarTabs(container);

            // Setear adaptadorBD al viewpager.
            viewPager = (ViewPager) view.findViewById(R.id.pager);
            poblarViewPager(viewPager);
            pestanas.setupWithViewPager(viewPager);
        }
        setupTabIcons();
        pestanas.getTabAt(pestanaDefecto).select();

        return view;
    }

    private void insertarTabs(ViewGroup container) {
        View padre = (View) container.getParent();
        appBar = (AppBarLayout) padre.findViewById(R.id.appbar);
        pestanas = new TabLayout(getActivity());
        pestanas.setTabTextColors(Color.parseColor("#FFFFFF"), Color.parseColor("#FFFFFF"));
        appBar.addView(pestanas);
    }

    private void setupTabIcons() {
        pestanas.getTabAt(0).setIcon(R.drawable.ic_person_white_24dp);
        pestanas.getTabAt(1).setIcon(R.drawable.ic_star_white_24dp);
        pestanas.getTabAt(2).setIcon(R.drawable.ic_history_white_24dp);
    }

    private void poblarViewPager(ViewPager viewPager) {
        AdaptadorPestanas adapter = new AdaptadorPestanas(getFragmentManager());
        adapter.addFragment(new FragmentoCuentaPerfil(), getString(R.string.titulo_tab_perfil));
        adapter.addFragment(new FragmentoCuentaFavoritos(), getString(R.string.titulo_tab_favoritos));
        adapter.addFragment(new FragmentoCuentaHistorial(), getString(R.string.titulo_tab_historial));
        viewPager.setAdapter(adapter);
    }


    @Override
    public void onDestroyView() {
        super.onDestroyView();
        appBar.removeView(pestanas);
    }

    /**
     * Un {@link FragmentStatePagerAdapter} que gestiona las secciones, fragmentos y
     * títulos de las pestañas
     */
    public class AdaptadorPestanas extends FragmentStatePagerAdapter {
        private final List<Fragment> fragmentos = new ArrayList<>();
        private final List<String> titulosFragmentos = new ArrayList<>();

        public AdaptadorPestanas(FragmentManager fm) {
            super(fm);
        }

        @Override
        public android.support.v4.app.Fragment getItem(int position) {
            return fragmentos.get(position);
        }

        @Override
        public int getCount() {
            return fragmentos.size();
        }

        public void addFragment(android.support.v4.app.Fragment fragment, String title) {
            fragmentos.add(fragment);
            titulosFragmentos.add(title);
        }

        @Override
        public CharSequence getPageTitle(int position) {
            return titulosFragmentos.get(position);
        }
    }
}
