package uoc.multimediadegree.com.e_lactancia_app.ui;

import android.annotation.SuppressLint;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.ListFragment;
import android.support.v4.app.LoaderManager;
import android.support.v4.content.CursorLoader;
import android.support.v4.content.Loader;
import android.support.v7.app.AlertDialog;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.ListView;

import uoc.multimediadegree.com.e_lactancia_app.Adaptador_BD;
import uoc.multimediadegree.com.e_lactancia_app.R;
import uoc.multimediadegree.com.e_lactancia_app.modelo.MyContracts;

public class FragmentoCuentaFavoritos extends ListFragment implements
        LoaderManager.LoaderCallbacks<Cursor> {
    private final static int COLUMN_FAV_REFWEB = 3;
    protected Adaptador_BD adaptadorBD;

    public FragmentoCuentaFavoritos() {
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // Habilitar al fragmento para contribuir en la action bar
        setHasOptionsMenu(true);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragmento_cuenta_favoritos, container, false);

        ImageButton fab = (ImageButton) view.findViewById(R.id.fab);
        fab.setOnClickListener(
                new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        if (getListView().getCount() != 0) {
                            deleteFavourites();
                        }
                    }
                }
        );
        return view;
    }

    private void deleteFavourites(){
        FragmentManager fragmentManager = getActivity().getSupportFragmentManager();
        DialogoConfirmacionFavoritos dialogo = new DialogoConfirmacionFavoritos();
        dialogo.show(fragmentManager, "Confirmación");
    }

    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);
        setListViewAdapter();
        getLoaderManager().initLoader(0, null, this);
    }

    public void setListViewAdapter(){
        adaptadorBD = new Adaptador_BD(getActivity(), adaptadorBD.FAVORITOS);
        setListAdapter(adaptadorBD);
    }

    @Override
    public void onListItemClick(ListView l, View v, int position, long id) {
        String terminoRefWeb = adaptadorBD.getCursor().getString(COLUMN_FAV_REFWEB);

        Intent intent;
        intent = new Intent(getActivity(), ActividadDetalleTermino.class);
        intent.putExtra("refWeb", terminoRefWeb);
        getActivity().startActivity(intent);
    }

    @Override
    public Loader<Cursor> onCreateLoader(int id, Bundle args) {
        // Consultar todos los registros
        return new CursorLoader(
                getActivity(),
                MyContracts.CONTENT_URI_FAVORITO,
                null, null, null, null);
    }

    @Override
    public void onLoadFinished(Loader<Cursor> loader, Cursor data) {
        adaptadorBD.swapCursor(data);
    }

    @Override
    public void onLoaderReset(Loader<Cursor> loader) {
        adaptadorBD.swapCursor(null);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        try {
            getLoaderManager().destroyLoader(0);
            if (adaptadorBD != null) {
                adaptadorBD.changeCursor(null);
                adaptadorBD = null;
            }
        } catch (Throwable localThrowable) {
            // Proyectar la excepción
        }
    }

    @SuppressLint("ValidFragment")
    public class DialogoConfirmacionFavoritos extends DialogFragment {
        @Override
        public Dialog onCreateDialog(Bundle savedInstanceState) {

            AlertDialog.Builder builder =
                    new AlertDialog.Builder(getActivity());

            builder.setMessage(getResources().getString(R.string.confirmDialogFavoritos_question))
                    .setTitle(getResources().getString(R.string.confirmDialogFavoritos_title))
                    .setPositiveButton(getResources().getString(R.string.confirmDialog_ok), new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int id) {
                            Log.i("Dialogos", "Confirmacion Aceptada.");
                            getActivity().getContentResolver().delete(MyContracts.CONTENT_URI_FAVORITO, "1", null);
                            setListViewAdapter();
                            dialog.cancel();
                        }
                    })
                    .setNegativeButton(getResources().getString(R.string.confirmDialog_cancel), new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int id) {
                            Log.i("Dialogos", "Confirmacion Cancelada.");
                            dialog.cancel();
                        }
                    });

            return builder.create();
        }
    }
}
