package uoc.multimediadegree.com.e_lactancia_app.ui;

import android.content.ContentUris;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.TextView;

import uoc.multimediadegree.com.e_lactancia_app.R;
import uoc.multimediadegree.com.e_lactancia_app.modelo.MyContracts;

/**
 * Fragmento para la pestaña "PERFIL" De la sección "Mi Cuenta"
 */
public class FragmentoCuentaPerfil extends Fragment{

    /** Textos del layout **/
    private TextView userName, userEMail, userProfile;
    /** Id de la actividad **/
    private long id = 1;

    public FragmentoCuentaPerfil() {
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragmento_cuenta_perfil, container, false);
        // Obtención de views
        userName = (TextView) view.findViewById(R.id.txt_perfil_userName);
        userEMail = (TextView) view.findViewById(R.id.txt_perfil_email);
        userProfile = (TextView) view.findViewById(R.id.txt_perfil_perfil);

        ImageButton fab = (ImageButton) view.findViewById(R.id.fab);
        fab.setOnClickListener(
                new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        beginUpdate();
                    }
                }
        );
        return view;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // Habilitar al fragmento para contribuir en la action bar
        setHasOptionsMenu(true);
    }

    @Override
    public void onResume() {
        super.onResume();
        //La tabla USUARIO sólo tiene 1 registro
        id = 1;//getActivity().getIntent().getLongExtra(MyContracts.Columnas._ID, -1);
        updateView(id);  // Actualzar la vista con los datos de la actividad
    }


    /**
     * Envía todos los datos de la actividad hacia el formulario
     * de actualización
     */
    private void beginUpdate() {
        getActivity()
                .startActivity(
                        new Intent(getActivity(), ActividadUpdateUser.class)
                                .putExtra(MyContracts.Columnas._ID, id)
                                .putExtra(MyContracts.Columnas.USER_NAME, userName.getText())
                                .putExtra(MyContracts.Columnas.USER_EMAIL, userEMail.getText())
                                .putExtra(MyContracts.Columnas.USER_PROFLIE, userProfile.getText())
                );
    }


    /**
     * Actualiza los textos del layout
     *
     * @param id Identificador de la actividad
     */
    private void updateView(long id) {
        if (id == -1) {
            userName.setText("");
            userEMail.setText("");
            userProfile.setText("");

            return;
        }

        Uri uri = ContentUris.withAppendedId(MyContracts.CONTENT_URI_USUARIO, id);
        Cursor c = getActivity().getContentResolver().query(
                uri,
                null, null, null, null);

        if (!c.moveToFirst())
            return;

        String userName_text = c.getString(c.getColumnIndex(MyContracts.Columnas.USER_NAME));
        String userEMail_text = c.getString(c.getColumnIndex(MyContracts.Columnas.USER_EMAIL));
        String userProfile_text = c.getString(c.getColumnIndex(MyContracts.Columnas.USER_PROFLIE));

        userName.setText(userName_text);
        userEMail.setText(userEMail_text);
        userProfile.setText(userProfile_text);

        c.close(); // Liberar memoria del cursor
    }
}
