package uoc.multimediadegree.com.e_lactancia_app.ui;

import android.content.ContentUris;
import android.content.ContentValues;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.Spinner;

import uoc.multimediadegree.com.e_lactancia_app.R;
import uoc.multimediadegree.com.e_lactancia_app.modelo.MyContracts;

/**
 * Fragmento con un formulario de actualización
 */
public class FragmentoUpdateUser extends Fragment {
    /**
     * Identificador de la actividad
     */
    private long id = 1;
    /**
     * Views del layout
     */
    private EditText userName;
    private EditText userEMail;
    private Spinner userProfile;

    public FragmentoUpdateUser() {
        // Required empty public constructor
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setHasOptionsMenu(true);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view = inflater.inflate(R.layout.fragmento_update_user, container, false);

        // Obtener views
        userName = (EditText) view.findViewById(R.id.upateUser_userName_input);
        userEMail = (EditText) view.findViewById(R.id.upateUser_userEMail_input);
        userProfile = (Spinner) view.findViewById(R.id.upateUser_spin_profile);

        return view;
    }

    @Override
    public void onResume() {
        super.onResume();
        id = 1;  //getActivity().getIntent().getLongExtra(MyContracts.Columnas._ID, -1);
        updateView(); // Cargar datos iniciales
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();

        switch (id) {
            case android.R.id.home:
                updateData(); // Actualizar
                getActivity().finish();
                return true;
            case R.id.action_discard:
                getActivity().finish();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }

    }

    /**
     * Actualizar datos de la actividad
     */
    private void updateData() {

        // Unir Uri principal con identificador
        Uri uri = ContentUris.withAppendedId(MyContracts.CONTENT_URI_USUARIO, id);

        ContentValues values = new ContentValues();
        values.put(MyContracts.Columnas.USER_NAME, userName.getText().toString());
        values.put(MyContracts.Columnas.USER_EMAIL, userEMail.getText().toString());
        values.put(MyContracts.Columnas.USER_PROFLIE, userProfile.getSelectedItem().toString());

        // Actualiza datos del Content Provider
        getActivity().getContentResolver().update(
                uri,
                values,
                null,
                null
        );
    }

    /**
     * Carga los datos que provienen desde el detalle
     */
    private void updateView() {
        // Obtener datos del formulario
        Intent i = getActivity().getIntent();
        String userName_text = i.getStringExtra(MyContracts.Columnas.USER_NAME);
        String userEMail_text = i.getStringExtra(MyContracts.Columnas.USER_EMAIL);
        String userProfile_text = i.getStringExtra(MyContracts.Columnas.USER_PROFLIE);

        // Actualizar la vista
        userName.setText(userName_text);
        userEMail.setText(userEMail_text);
        userProfile.setSelection(getIndex(userProfile, userProfile_text));
    }

    /**
     * Obtiene el indice de un {@link Spinner} según el valor
     * de una cadena
     *
     * @param spinner Instancia del spinner
     * @param value   Cadena a buscar
     * @return Posición donde se encuentra
     */
    private int getIndex(Spinner spinner, String value) {
        int index = 0;

        for (int i = 0; i < spinner.getCount(); i++) {
            if (spinner.getItemAtPosition(i).toString().equalsIgnoreCase(value)) {
                index = i;
                break;
            }
        }
        return index;
    }
}

